// Display.h

#ifndef SCREEN_H
#define SCREEN_H

#include <GraphicsDefs.h>

#include "FrameBuffer.h"

// abstraction for the actual output device
class Display {
public:
								Display();
	virtual						~Display();

	virtual	status_t			Init() = 0;
	virtual	void				Cleanup() = 0;

	virtual	FrameBuffer			GetFrameBuffer() = 0;

	virtual	void				SetPalette(const rgb_color *colors) = 0;
	virtual	void				GetPalette(rgb_color *colors) = 0;

	virtual	void				Refresh(int32 frame);
};

#endif	// SCREEN_H
